package cse1030;

import java.awt.GridLayout;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

@SuppressWarnings("serial")
public class SimpleView extends JFrame {

  private JLabel rollValue;
  private JButton rollButton;
  private ImageIcon[] faces;
  
  public SimpleView(SimpleModel model, SimpleController controller) {
    super("Simple View Example");
    
    this.faces = new ImageIcon[6];
    for (int i = 1; i <= 6; i++) {
      String filename = String.valueOf(i) + ".png";
      ImageIcon icon = createImageIcon(filename, "");
      faces[i - 1] = icon;
    }
    
    this.rollValue = new JLabel();
    this.setRoll(model.getValue());
    this.rollButton = new JButton("Roll");
    this.rollButton.addActionListener(controller);
    this.rollButton.setActionCommand(SimpleController.ROLL);
    
    this.setLayout(new GridLayout(2, 1));
    this.add(rollValue);
    this.add(rollButton);
    this.pack();
    
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }
  
  public void setRoll(String value) {
    this.rollValue.setText(value);
    int v = Integer.parseInt(value);
    this.rollValue.setIcon(this.faces[v - 1]);
  }

  protected ImageIcon createImageIcon(String path, String description) {
    java.net.URL imgURL = getClass().getResource(path);
    if (imgURL != null) {
      return new ImageIcon(imgURL, description);
    } else {
      System.err.println("Couldn't find file: " + path);
      return null;
    }
  }
}
